<?php
/*
 * Class Name : GFHANNANSMS_Pro_{strtoupper( php file name) }	
 */
class GFHANNANSMS_Pro_RASTINSMS {

	/*
	* Gateway title	
	*/
	public static function name($gateways) {
	
		$name = __('راستین اس ام اس', 'GF_SMS' );
		
		$gateway = array( strtolower( str_replace( 'GFHANNANSMS_Pro_', '', get_called_class())) => $name );
		return array_unique( array_merge( $gateways , $gateway ) );
	}
	
	
	/*
	* Gateway parameters
	*/
	public static function options(){
		return array(
			'username'  => __('نام کاربری','GF_SMS'),
			'password'  => __('پسورد','GF_SMS')
		);
	}

	/*
	* Gateway credit
	*/
	public static function credit(){
		return true;
	}
	

	/*
	* Gateway action
	*/	
	public static function process( $options, $action, $from, $to, $messages ){
	
		if ( $action == 'credit' && !self::credit() ) {
			return false;
		}
		
		if ( ! extension_loaded('soap') )
			return __('ماژول Soap بر روی هاست شما فعال نمی باشد .','GF_SMS');
		
		
		
		$username = $options['username'];
		$password = $options['password'];
		
		ini_set("soap.wsdl_cache_enabled", "0");
		
		$to = explode(',', $to);
		$i = sizeOf($to);
		while($i--){
			$uNumber = Trim($to[$i]);
			$ret = &$uNumber;
			if (substr($uNumber,0, 5) == '%2B98'){ 
				$ret = substr($uNumber, 5);
			}
			if (substr($uNumber,0, 5) == '%2b98'){ 
				$ret = substr($uNumber, 5);
			}
			if (substr($uNumber,0, 4) == '0098'){ 
				$ret = substr($uNumber, 4);
			}
			if (substr($uNumber,0, 3) == '098')	{ 
				$ret = substr($uNumber, 3);
			}
			if (substr($uNumber,0, 3) == '+98'){ 
				$ret = substr($uNumber, 3);
			}
			if (substr($uNumber,0, 2) == '98'){ 
				$ret = substr($uNumber, 2);
			}
			$to[$i] =  '0' . $ret;
		}
		
		try	{
			$parameters['Username'] = $username;
			$parameters['PassWord'] = $password;
			$parameters['SenderNumber'] = $from;
			$parameters['RecipientNumbers']= $to;
			$parameters['MessageBodie']= $messages;
			$parameters['Type'] = 1;
			$parameters['AllowedDelay']= 0;
		
	
			if ($action == "send") {
				$client = new SoapClient("https://www.rastinsms.com/ws/v2/ws.asmx?WSDL");	
				$send = $client->SendMessage($parameters)->SendMessageResult ;
			}
			
			if ($action == "credit") {
				$client = new SoapClient("https://www.rastinsms.com/ws/v2/ws.asmx?WSDL");	
				$credit = $client->GetCredit(array("Username"=> $parameters['Username'] ,"PassWord"=>$parameters['PassWord']))->GetCreditResult;;
			}
			
			
		}
		catch (SoapFault $ex) {
			$errorstr = $ex->faultstring;
		}
		
		
		if ($action == "send"){
			if ( $send == -1 ) {
				return __('نام کاربری یا کلمه عبور اشتباه است .', 'GF_SMS' );
			}
			else if ( $send == -2 ){
				return __('ارسال وبسرویس برای کاربر غیرفعال است .', 'GF_SMS' );
			}
			else if ( $send == -3 ){
				return __('سرویس موقتا غیرفعال است.', 'GF_SMS' );
			}
			else if ( $send == -4 ){
				return __('شماره فرستنده متعلق به این کاربر نیست .', 'GF_SMS' );
			}
			else if ( $send == -5 ){
				return __('شماره تلفن همراه گیرنده اشتباه است', 'GF_SMS' );
			}
			else if ( $send == -6 ){
				return __('اعتبار کاربر برای ارسال کافی نیست', 'GF_SMS' );
			}
			else if ( $send == -7 ){
				return __('آرایه گیرندگان خالی است.', 'GF_SMS' );
			}
				else if ( $send == -8 ){
				return __('تعداد شماره های گیرنده موجود در آرایه بیشتر از تعدادمجاز است', 'GF_SMS' );
			}
			else if ( $send == -9 ){
				return __('شماره فرستنده اشتباه است .', 'GF_SMS' );
			}
			else if ( $send == -10 ){
				return __('آرایه شناسه پیام خالی است', 'GF_SMS' );
			}
			else if ( $send == -11 ){
				return __('حساب کاربر مسدود است', 'GF_SMS' );
			}
			else if ( $send == -12 ){
				return __('تلفن همراه کاربر فعال نیست.', 'GF_SMS' );
			}
			else if ( $send == -13 ){
				return __('ایمیل کاربر فعال نیست.', 'GF_SMS' );
			}
			else if ( $send == -14 ){
				return __('شماره اختصاصی گیرنده پیام اشتباه است.', 'GF_SMS' );
			}
			else if ( $send == -15 ){
				return __('تعداد پیامک درخواستی خارج از محدوده مجاز', 'GF_SMS' );
			}
			else if ( $send == -16 ){
				return __('تاخیر محاز باید عددی بین 0 تا 24 باشد', 'GF_SMS' );
			}
			else if ( $send == -18 ){
				return __('متن پیام اشتباه است.', 'GF_SMS' );
			}
			else if ( $send == -19 ){
				return __('تعداد خانه های آرایه متن باید برابر 1 یا به تعداد خانه های آرایه دریافت کننده باشد', 'GF_SMS' );
			}
			else if ( $send == -20 ){
				return __('تعداد خانه های آرایه فرستنده باید برابر 1 یا به تعداد خانه های آرایه دریافت کننده باشد', 'GF_SMS' );
			}
			else if ( $send == -21 ){
				return __('تعداد خانه های آرایه تاخیر مجاز  باید برابر 1 یا به تعداد خانه های آرایه دریافت کننده باشد.', 'GF_SMS' );
			}
			else if ( $send <-30 ){
				return __('خطای داخلی ، درخواست مجدد.', 'GF_SMS' );
			}
		
			else if ( $send >0 ){
				return 'OK';
			}
			else {
				return __('خطای ناشناخته .', 'GF_SMS' );
			}
		}
		
		if ($action == "credit") {
			if ( $credit == -1 ) {
				return __('نام کاربری یا کلمه عبور اشتباه است .', 'GF_SMS' );
			}
			return ( (int) $credit ) . __(' پیامک', 'GF_SMS' );
		}

		
		if ($action == "range"){
			$min = 100;
			$max = 200;
			return array("min" => $min, "max" => $max);
		}

	}
}